
import java.rmi.Naming;
import java.rmi.RemoteException;

import java.rmi.server.UnicastRemoteObject;

public
class HHQueue
extends UnicastRemoteObject
implements HQueue
{
  private LinkedList _linkedlistMessages = new LinkedList();

  public
  HHQueue()
  throws RemoteException
  {
    System.out.println("HHQueue:HHQueue");
  }

  public
  void
  send(Message message)
  throws RemoteException
  {
    synchronized (_linkedlistMessages)
    {
      _linkedlistMessages.add(message);

      _linkedlistMessages.notifyAll();
    }

    System.out.println("HHQueue:send: " + message);
  }

  public
  Message
  receive()
  throws RemoteException
  {
    Message message = null;

    synchronized (_linkedlistMessages)
    {
      while ((message = (Message)_linkedlistMessages.remove()) == null)
      {
        try
        {
          _linkedlistMessages.wait();
        }
        catch (InterruptedException exception)
        {
          break;
        }
      }
    }

    System.out.println("HHQueue:receive: " + message);

    return message;
  }

  public
  static
  void
  main(String [] rgstring)
  {
    try
    {
      Naming.rebind(rgstring[0], new HHQueue());
    }
    catch (Exception exception)
    {
      System.out.println(exception);
    }
  }
}
