
import java.rmi.Naming;
import java.rmi.RemoteException;

import java.rmi.server.UnicastRemoteObject;

import java.util.Enumeration;

public
class HHTopic
extends UnicastRemoteObject
implements HTopic
{
  private LinkedList _linkedlistSubscribers = new LinkedList();

  public
  HHTopic()
  throws RemoteException
  {
    System.out.println("HHTopic:HHTopic");
  }

  public
  void
  publish(Message message)
  throws RemoteException
  {
    synchronized (_linkedlistSubscribers)
    {
      Enumeration enumeration = _linkedlistSubscribers.elements();

      while (enumeration.hasMoreElements())
      {
        MessageListener messagelistener = (MessageListener)enumeration.nextElement();

        messagelistener.onMessage(message);
      }
    }

    System.out.println("HHTopic:publish: " + message);
  }

  public
  void
  setMessageListener(MessageListener messagelistener)
  throws RemoteException
  {
    synchronized (_linkedlistSubscribers)
    {
      _linkedlistSubscribers.add(messagelistener);
    }

    System.out.println("HHTopic:setMessageListener");
  }

  public
  static
  void
  main(String [] rgstring)
  {
    try
    {
      Naming.rebind(rgstring[0], new HHTopic());
    }
    catch (Exception exception)
    {
      System.out.println(exception);
    }
  }
}
