
import java.util.Enumeration;

public
class LinkedList
{
  class Node
  {
    Node _nodePrevious = null;

    Object _object = null;

    Node(Object object)
    {
      _object = object;
    }
  };

  private Node _nodeTop = null;
  private Node _nodeBottom = null;

  public
  synchronized
  void
  add(Object object)
  throws NullPointerException
  {
    if (object == null)
    {
      throw new NullPointerException("null object");
    }

    Node node = new Node(object);

    if (_nodeTop == null)
    {
      _nodeTop = node;
    }

    if (_nodeBottom == null)
    {
      _nodeBottom = node;
    }
    else
    {
      _nodeBottom._nodePrevious = _nodeBottom = node;
    }
  }

  public
  synchronized
  Object
  remove()
  {
    if (_nodeTop == null)
    {
      return null;
    }

    Node node = _nodeTop;

    if (_nodeTop._nodePrevious == null)
    {
      _nodeTop = _nodeBottom = null;
    }
    else
    {
      _nodeTop = _nodeTop._nodePrevious;
    }

    return node._object;
  }

  class LinkedListEnumeration
  extends LinkedList
  implements Enumeration
  {
    private Node _node = null;

    LinkedListEnumeration(Node nodeStart)
    {
      _node = nodeStart;

      while (_node != null)
      {
        this.add(_node._object);

        _node = _node._nodePrevious;
      }

      _node = _nodeTop;
    }

    public
    synchronized
    boolean
    hasMoreElements()
    {
      return _node != null;
    }

    public
    synchronized
    Object
    nextElement()
    {
      Object object = _node._object;

      _node = _node._nodePrevious;

      return object;
    }
  };

  public
  synchronized
  Enumeration
  elements()
  {
    return new LinkedListEnumeration(_nodeTop);
  }
}
